@echo off
if "%OS%" == "Windows_NT" setlocal

rem Checks status of JobServer environment and runs various functions

set COMMAND=%1
set PARAM1=%2
set PARAM2=%3
set PARAM3=%4
set PARAM4=%5
set PARAM5=%6
set PARAM6=%7
set PARAM7=%8
set PARAM8=%9
set PARAM9=%10

if "%1" == "" set COMMAND=-status
set dumby=""
if "%command%" == "-gstop" goto okStart
set dumby="" 
if "%command%" == "-xstop" goto okStart
set dumby=""
if "%command%" == "-start" goto okStart
set dumby="" 
if "%command%" == "-gstart" goto okStart
set dumby=""
if "%command%" == "-hstart" goto okStart
set dumby=""
if "%command%" == "-enableAll" goto okStart
set dumby=""
if "%command%" == "-disableAll" goto okStart
set dumby=""
if "%command%" == "-disableSchedOnly" goto okStart
set dumby=""
if "%command%" == "-killcontainer" goto okStart
set dumby=""
if "%command%" == "-killagent" goto okStart
set dumby=""
if "%command%" == "-status" goto okStart
set dumby=""
if "%command%" == "-ping" goto okStart
set dumby=""
if "%command%" == "-pingagent" goto okStart
set dumby=""
if "%command%" == "-resetAdmin" goto okStart
set dumby=""
if "%command%" == "-resetInstallTag" goto okStart
set dumby=""
if "%command%" == "-syslog" goto okStart
set dumby=""
if "%command%" == "-syslogdetail" goto okStart
set dumby=""
if "%command%" == "-startuplog" goto okStart
set dumby=""
if "%command%" == "-webserverlog" goto okStart
set dumby=""
if "%command%" == "-wstrigger" goto okStart
set dumby=""
if "%command%" == "-wsrule" goto okStart
set dumby=""
if "%command%" == "-wsjobserverstatus" goto okStart
set dumby=""
if "%command%" == "-wswebserverstatus" goto okStart
set dumby=""
if "%command%" == "-simplewebserverstatus" goto okStart
set dumby=""
if "%command%" == "-simplewsprestopwebserver" goto okStart
set dumby=""
if "%command%" == "-dbheartbeat" goto okStart
set dumby=""
if "%command%" == "-dblocalshutdown" goto okStart
set dumby=""
if "%command%" == "-export" goto okStart
set dumby=""
if "%command%" == "-exportpartition" goto okStart
set dumby=""
if "%command%" == "-exportgroup" goto okStart
set dumby=""
if "%command%" == "-import" goto okStart
set dumby=""
if "%command%" == "-importgroup" goto okStart
set dumby=""
if "%command%" == "-importpartition" goto okStart
set dumby=""
if "%command%" == "-shadow" goto okStart
set dumby=""

:theHelp
     echo.
     echo Command help: jsmonitor options:
     echo.
     echo   -status       : Status of environment.
     echo   -gstop        : Graceful shutdown of server.
     echo   -hstart       : Put JS Container into previous running mode it was in, when it was shutdown last.
     echo   -xstop        : Immediate shutdown of server.
     echo   -start        : Startup of jobserver scheduling engine (jobserver must be in idle state)
     echo   -gstart       : Graceful startup of jobserver scheduling engine (leaves queue and scheduler 
     echo                   in disabled mode)
     echo   -killcontainer: Like -xstop but will also kill the process/container.
     
     echo   -resetAdmin [new password]  : Reset password for admin user.
REM     echo   -resetInstallTag : Will reset installation tag used to keep installation
REM     echo                      and database in sync.
     
     echo   -syslog [serverid] : Return log file dump of server. Most current 
     echo                        log is returned, if no serverid provided.
     
     echo   -syslogdetail [yyyy-mm-dd] [yyyy-mm-dd]: Gets start/stop details of server
     echo                                            If not dates entered then most current
     echo                                            detail are grabbed.
     
     echo   -startuplog    : Return dump of startup log file.
     echo   -webserverlog  : Return dump of most current webserver log file.
     
     echo   -wstrigger [username] [password] [job id] [arg1=value arg2=value arg3=value.....]
     echo                  : Force job to run via WebService. Optional arguements (name/value pairs) can be
     echo                    passed to the job when it runs.
     
     echo   -wsrule [username] [password] [rulename] [yes / no]
     echo           [yyyy-mm-dd hh:mm:ss] [yyyy-mm-dd hh:mm:ss] : Change 
     echo                                                         dependency rule status via WS.
     echo   -wsjobserverstatus: Uses JobServer webservice API to return mode of JobServer
     echo                       Container/Scheduler in exit status. Returns same results
     echo                       as -mode.
     echo   -wswebserverstatus: Uses JobServer webservice API to return status of Web Server

     echo                      in exit status. Returns 1 if webserver found, 0 otherwise.
     echo   -export [job/app id] -r [remote JS URL] [username] [password]
     echo                         : Export job or app and dump the jobx files into the current local directory.
     echo                           If optional -r flag is used, then it will export jobs/apps from a remote
     echo                           JS env.
     echo   -exportpartition [partition name] -r [remote JS URL] [username] [password]
     echo                         : Export all jobs in given partition and dump the jobx files into the current
     echo                           local directory.  If optional -r flag is used, then it will export partition
     echo                           jobs from a remote JS env. This command only applies to jobs, but not apps.
     echo   -exportgroup [group name] -r [remote JS URL] [username] [password]
     echo                         : Export all jobs/apps in given group and dump the jobx files into the current
     echo                           local directory. If optional -r flag is used, then it will export group jobs/apps
     echo                           from a remote JS env.
     echo   -import [jobx filename^|job/app id] [active^|pause^|stop] -r [remote JS URL] [username] [password]
     echo                : Import jobx file into this local JS environment or import job/app, by id, from a remote
     echo                  JS env into this local JS env. During import if a jobs partition or group are not found,
     echo                  the job/app will be put into the JS default partition/group. If "?" is specified as the
     echo                  first argument, then all the files in the current directory with extension jobx will be
     echo                  imported from the current directory. The second param (optional) allows changing the run
     echo                  status of the job when the is imported. If optional -r flag is used, then it will fetch
     echo                  remote job/app, by id, from a remote JS env and import it into this local JS.
     echo   -importpartition [partition name] [active^|pause^|stop] [remote JS URL] [username] [password]
     echo                : Import all jobs of a partition, from a remote JS, into this JS environment. If a jobs
     echo                  partition or group are not found during import, the job will be put into the JS
     echo                  default partition/group. The second param (optional) allows changing the run status of
     echo                  the job when imported.
     echo   -importgroup [group name] [active^|pause^|stop] -r [remote JS URL] [username] [password]
     echo                : Import all jobs/apps of a group, from a remote JS, into this JS environment. If a jobs
     echo                  partition or group are not found during import, the job/app will be put into the JS
     echo                  default partition/group. The second param (optional) allows changing the run status of
     echo                  the job when imported.
     echo   -mode  : Returns mode of JobServer Container and Scheduler with command exit status.
     echo              1 - Server Idling
     echo              2 - Server running: scheduler and queue enabled
     echo              3 - Server running: scheduler and queue disabled
     echo              4 - Server running: queue enabled ^& scheduler diabled
     echo              8 - Server running: queue disabled ^& scheduler enabled
     echo              5 - Server running: in graceful shutdown mode
     echo              6 - Server running: in immediate shutdown mode
     echo              7 - Server NOT running and Container NOT available
     echo   -disableAll   : temporarly pause^ the running of all Jobs in the scheduler
		 echo                   including jobs in queue (disables Scheduler and Queue).
     echo   -enableAll    : reactivate running of all Jobs in the scheduler (enabled mode
		 echo                   also used to take server out of gstart mode).
     echo   -disableSchedOnly : disable scheduler only (jobs in queue continue to be
		 echo                       vailable for running) - if all enabled will disable
		 echo                       scheduler only - if all disabled will enable queue and
		 echo                       keep scheduler disabled.
     echo   -shadow : Create shadow string.
     echo.

goto end

:okStart
     
if "%JOBSERVER_HOME%" == "" goto guessIt
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome

rem Even though it is set and not correct try to guess
:guessIt
set JOBSERVER_HOME=.
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
rem Try to guess what JOBSERVER_HOME is
set JOBSERVER_HOME=..
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
set JOBSERVER_HOME=..\..
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
echo "The JOBSERVER_HOME environment variable is not set. This"
echo "variable needs to be set to run this program. Program"
echo "exiting."
goto end

:okHome
call "%JOBSERVER_HOME%\conf\system-config.bat"

if exist "%JAVA_HOME%\bin\java.exe" goto okExec
echo "The JAVA_HOME environment variable is not set. This"
echo "variable needs to be set to run this program. Program"
echo "exiting."
goto end

:okExec
set JS_USER_DIR=%CD%
cd /D "%JOBSERVER_HOME%"

set JOBSERVER_HOME=%CD%

set JSLIB=sys\lib
set MULELIB=mule\my-mule-lib

set CAT_VAR=""
FOR %%f IN (%JSLIB%\jscore\*.jar) DO call "bin\toolbin\parsecmd.bat" %%f
FOR %%f IN (%JSLIB%\jsthird\*.jar) DO call "bin\toolbin\parsecmd.bat" %%f
FOR %%f IN (%JSLIB%\endorsed\*.jar) DO call "bin\toolbin\parsecmd.bat" %%f
rem FOR %%f IN (%JSLIB%\mule-core\*.jar) DO call "bin\toolbin\parsecmd.bat" %%f
rem FOR %%f IN (%JSLIB%\mule-opt\*.jar) DO call "bin\toolbin\parsecmd.bat" %%f
rem FOR %%f IN (%JSLIB%\mule-user\*.jar) DO call "bin\toolbin\parsecmd.bat" %%f
rem FOR %%f IN (%MULELIB%\*.jar) DO call "bin\toolbin\parsecmd.bat" %%f
set CLASSPATH=%CAT_VAR%

for /F "usebackq" %%i IN (`hostname`) DO set jshost=%%i
set JS_SERVER_HOSTNAME=%jshost%
if "%JOBSERVER_HOSTNAME%" == "" goto stepLocalhost
set JS_SERVER_HOSTNAME=%JOBSERVER_HOSTNAME%
:stepLocalhost

set DEFINES2=-Djs.webServerHttpPort=%webServerHttpPort%
set DEFINES2=%DEFINES2% -Djs.ldapAuth=%ldapAuth%
set DEFINES2=%DEFINES2% -Djs.clearPW=%clearPW%
set DEFINES2=%DEFINES2% -Djs.agentPort=%agentPort%
set DEFINES2=%DEFINES2% -Djs.useMule=%useMule%
set DEFINES2=%DEFINES2% -Djs.webServerShutdownPort=%webServerShutdownPort%
set DEFINES2=%DEFINES2% -Djs.soapPort=%soapPort%
set DEFINES2=%DEFINES2% -Djs.containerRemotePort=%containerRemotePort%
set DEFINES2=%DEFINES2% -Djs.dbDriverType=%dbDriverType%
set DEFINES2=%DEFINES2% -Djs.dbPort=%dbPort%
set DEFINES2=%DEFINES2% -Djs.dbHost=%dbHost%
set DEFINES2=%DEFINES2% -Djs.dbName=%dbName%
set DEFINES2=%DEFINES2% -Djs.dbCustomJDBCURL=%dbCustomJDBC%
set DEFINES2=%DEFINES2% -Djs.dbUsername=%dbUsername%
set DEFINES2=%DEFINES2% -Djs.dbPassword=%dbPassword%
set DEFINES2=%DEFINES2% -Djs.dbSchemaName=%dbSchemaName%
set DEFINES2=%DEFINES2% -Djs.maxPoolSize=%maxPoolSize%
set DEFINES2=%DEFINES2% -Djs.holdPoolSize=%holdPoolSize%
set DEFINES2=%DEFINES2% -Djs.initPoolSize=%initPoolSize%
set DEFINES2=%DEFINES2% -Djs.servletMaxPoolSize=%servletMaxPoolSize%
set DEFINES2=%DEFINES2% -Djs.servletHoldPoolSize=%servletHoldPoolSize%
set DEFINES2=%DEFINES2% -Djs.servletInitPoolSize=%servletInitPoolSize%
set DEFINES2=%DEFINES2% -Djs.debug=%debug%
set DEFINES2=%DEFINES2% -Djs.debugLevel=%debugLevel%
set DEFINES2=%DEFINES2% -Djs.debugClasses=%debugClasses%
set DEFINES2=%DEFINES2% -Djs.jsInstanceVersion=%jsInstanceVersion%
set DEFINES2=%DEFINES2% -Djs.useSSL=%useSSL%
set DEFINES2=%DEFINES2% -Djs.serverHostname=%JS_SERVER_HOSTNAME%
set DEFINES2=%DEFINES2% -Djs.primarySchedServer=%primarySchedServer%
set DEFINES2=%DEFINES2% -Djs.secondarySchedServer=%secondarySchedServer%
set DEFINES2=%DEFINES2% -Djs.webletModeOnly=%webletModeOnly%
set DEFINES2=%DEFINES2% -DEJS_HOME="%JOBSERVER_HOME%"
set DEFINES2=%DEFINES2% -Dmule.home="%JOBSERVER_HOME%\EJS-DATA"
set DEFINES2=%DEFINES2% -Dmule.working.dir="%JOBSERVER_HOME%\EJS-DATA\.mule"
set DEFINES2=%DEFINES2% -Djs.user.dir="%JS_USER_DIR%"

set MON_DEFINES=%MON_DEFINES% -DEJS_HOME="%JOBSERVER_HOME%"
set MON_DEFINES=%MON_DEFINES% -DCOMMAND=%COMMAND%
set MON_DEFINES=%MON_DEFINES% -DPARAM1=%PARAM1%
set MON_DEFINES=%MON_DEFINES% -DPARAM2=%PARAM2%
set MON_DEFINES=%MON_DEFINES% -DPARAM3=%PARAM3%
set MON_DEFINES=%MON_DEFINES% -DPARAM4=%PARAM4%
set MON_DEFINES=%MON_DEFINES% -DPARAM5=%PARAM5%
set MON_DEFINES=%MON_DEFINES% -DPARAM6=%PARAM6%

rem set MON_DEFINES=%MON_DEFINES% -Djavax.xml.parsers.SAXParserFactory=org.apache.xerces.jaxp.SAXParserFactoryImpl
set MON_DEFINES=%MON_DEFINES% -Djava.endorsed.dirs=%JSLIB%\endorsed

rem Debug settings of the local running code in this client program
set MON_DEFINES=%MON_DEFINES% -DTOOL_DEBUG_MODE=off
set MON_DEFINES=%MON_DEFINES% -DTOOL_DEBUG_LEVEL=3
set MON_DEFINES=%MON_DEFINES% -DTOOL_DEBUG_CLASSES=ALL
set MON_DEFINES=%MON_DEFINES% -DTOOL_DEBUG_FILE=\tmp\debug.txt

rem echo %MON_DEFINES%

"%JAVA_HOME%\bin\java.exe" %MON_DEFINES% %DEFINES2% -cp %CLASSPATH% surda.jobserver.client.WbServerClient

if NOT "%1" == "" goto end
pause

:end
