@echo off
if "%OS%" == "Windows_NT" setlocal

rem Starts up JobServer container

if "%JOBSERVER_HOME%" == "" goto guessIt
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
echo 
rem Even though it is set and not correct try to guess
:guessIt
set JOBSERVER_HOME=.
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
rem Try to guess what JOBSERVER_HOME is
set JOBSERVER_HOME=..
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
set JOBSERVER_HOME=..\..
if exist "%JOBSERVER_HOME%\conf\system-config.bat" goto okHome
echo The JOBSERVER_HOME environment variable is not set. This
echo variable needs to be set to run this program. Program
echo exiting.
goto end

:okHome
call "%JOBSERVER_HOME%\conf\system-config.bat"

if exist "%JAVA_HOME%\bin\java.exe" goto okExec
echo The JAVA_HOME environment variable is not set. This
echo variable needs to be set to run this program. Program
echo exiting.
goto end

:okExec
cd /D "%JOBSERVER_HOME%"

set JOBSERVER_HOME=%CD%

set JSLIB=sys\lib

set CAT_VAR=""
FOR %%f IN (%JSLIB%\jscore\*.jar) DO call "%JOBSERVER_HOME%\bin\toolbin\parsecmd.bat" %%f
FOR %%f IN (%JSLIB%\jsthird\*.jar) DO call "%JOBSERVER_HOME%\bin\toolbin\parsecmd.bat" %%f
rem FOR %%f IN (%JSLIB%\mule-opt\log4j*.jar) DO call "%JOBSERVER_HOME%\bin\toolbin\parsecmd.bat" %%f
set CLASSPATH=%CAT_VAR%

for /F "usebackq" %%i IN (`hostname`) DO set jshost=%%i
set JS_SERVER_HOSTNAME=%jshost%
if "%JOBSERVER_HOSTNAME%" == "" goto stepLocalhost
set JS_SERVER_HOSTNAME=%JOBSERVER_HOSTNAME%
:stepLocalhost

set DEFINES2=-Djs.webServerHttpPort=%webServerHttpPort%
set DEFINES2=%DEFINES2% -Djs.ldapAuth=%ldapAuth%
set DEFINES2=%DEFINES2% -Djs.clearPW=%clearPW%
set DEFINES2=%DEFINES2% -Djs.webServerShutdownPort=%webServerShutdownPort%
set DEFINES2=%DEFINES2% -Djs.soapPort=%soapPort%
set DEFINES2=%DEFINES2% -Djs.agentPort=%agentPort%
set DEFINES2=%DEFINES2% -Djs.useMule=%useMule%
set DEFINES2=%DEFINES2% -Djs.containerRemotePort=%containerRemotePort%
set DEFINES2=%DEFINES2% -Djs.dbDriverType=%dbDriverType%
set DEFINES2=%DEFINES2% -Djs.dbPort=%dbPort%
set DEFINES2=%DEFINES2% -Djs.dbHost=%dbHost%
set DEFINES2=%DEFINES2% -Djs.dbName=%dbName%
set DEFINES2=%DEFINES2% -Djs.dbCustomJDBCURL=%dbCustomJDBC%
set DEFINES2=%DEFINES2% -Djs.dbUsername=%dbUsername%
set DEFINES2=%DEFINES2% -Djs.dbPassword=%dbPassword%
set DEFINES2=%DEFINES2% -Djs.dbSchemaName=%dbSchemaName%
set DEFINES2=%DEFINES2% -Djs.maxPoolSize=%maxPoolSize%
set DEFINES2=%DEFINES2% -Djs.holdPoolSize=%holdPoolSize%
set DEFINES2=%DEFINES2% -Djs.initPoolSize=%initPoolSize%
set DEFINES2=%DEFINES2% -Djs.servletMaxPoolSize=%servletMaxPoolSize%
set DEFINES2=%DEFINES2% -Djs.servletHoldPoolSize=%servletHoldPoolSize%
set DEFINES2=%DEFINES2% -Djs.servletInitPoolSize=%servletInitPoolSize%
set DEFINES2=%DEFINES2% -Djs.debug=%debug%
set DEFINES2=%DEFINES2% -Djs.debugLevel=%debugLevel%
set DEFINES2=%DEFINES2% -Djs.debugClasses=%debugClasses%
set DEFINES2=%DEFINES2% -Djs.jsInstanceVersion=%jsInstanceVersion%
set DEFINES2=%DEFINES2% -Djs.useSSL=%useSSL%
set DEFINES2=%DEFINES2% -Djs.serverHostname=%JS_SERVER_HOSTNAME%
set DEFINES2=%DEFINES2% -Djs.primarySchedServer=%primarySchedServer%
set DEFINES2=%DEFINES2% -Djs.secondarySchedServer=%secondarySchedServer%
set DEFINES2=%DEFINES2% -Djs.webletModeOnly=%webletModeOnly%

set DEFINES=%DEFINES% -DEJS_HOME="%JOBSERVER_HOME%"
set DEFINES=%DEFINES% -DCOMMAND=-initializeDB
set DEFINES=%DEFINES% -DOPTION1=%1
set DEFINES=%DEFINES% -DOPTION2=%2
set DEFINES=%DEFINES% -DOPTION3=%3
set DEFINES=%DEFINES% -DOPTION4=%4
set DEFINES=%DEFINES% -DOPTION5=%5
set DEFINES=%DEFINES% -DOPTION6=%6
set DEFINES=%DEFINES% -DOPTION7=%7
set DEFINES=%DEFINES% -DOPTION8=%8
set DEFINES=%DEFINES% -Djs.tooldebug=%JS_DB_TOOL_DEBUG%

rem Debug settings of the local running code in this client program
set DEFINES=%DEFINES% -DTOOL_DEBUG_MODE=off
set DEFINES=%DEFINES% -DTOOL_DEBUG_LEVEL=3
set DEFINES=%DEFINES% -DTOOL_DEBUG_CLASSES=ALL
set DEFINES=%DEFINES% -DTOOL_DEBUG_FILE=\tmp\debug.txt

set DEFINES=%DEFINES% -DPID_FILENAME=%WEBSERVER_XML_FILE%
set DEFINES=%DEFINES% -DSERVER_XML_FILE=%WEBSERVER_XML_FILE%

rem %DEFINES%

"%JAVA_HOME%\bin\java.exe" %DEFINES% %DEFINES2% -cp %CLASSPATH% surda.jobserver.client.EnvSetupTool

:end
